Require Export gbR.

Goal forall x t:R, x^2<>1 -> x<>1.
gbR.
Qed.

Goal forall x t:R, x^2<>1 -> x<>1.
 (* with JC.Faugere algorithm F4 *)
 gbR_begin; check_gbR
 (1 - 0)
 (List.cons (x - 1) (List.cons (x0 * (x * (x * 1) - 1) - 1) List.nil))
 (List.cons x0 (List.cons x List.nil))

(lceq (Const 1 1)
   (lceq (Const 1 1)
      (lceq
         (Add
            (Add Zero
               (Mul
                  (Add (Add Zero (Mul (Const 0 1) (Const 1 1)))
                     (Mul (Const 1 1) (Pow (Var 1) 1))) (Const 1 1)))
            (Mul
               (Add (Add Zero (Mul (Const 0 1) (Const 1 1)))
                  (Mul (Const 1 1) (Pow (Var 1) 1))) (Pow (Var 2) 1)))
         (lceq (Const (-1) 1) lnil))))
 .
Qed.

Goal forall x y z:R, x^2+x*y=0 -> y^2+x*y=0 -> x+y=0.
gbR.
Qed.

Goal forall x y z:R, x^2+x*y=0 -> y^2+x*y=0 -> x+y=0.
 (* with JC.Faugere algorithm F4 *)
 gbR_begin; check_gbR
 (x + y - 0)
 (List.cons (x * (x * 1) + x * y) (List.cons (y * (y * 1) + x * y) List.nil))
 (List.cons y (List.cons x List.nil))

(lceq
   (Pow
      (Add
         (Add Zero
            (Mul
               (Add (Add Zero (Mul (Const 0 1) (Const 1 1)))
                  (Mul (Const 1 1) (Pow (Var 1) 1))) (Const 1 1)))
         (Mul (Const 1 1) (Pow (Var 2) 1))) 2)
   (lceq (Const 1 1) (lceq (Const 1 1) (lceq (Const 1 1) lnil))))
 .
Qed.

Require Export gbZ.

Goal forall x y z:Z,
  x+y+z=0 -> x*y+y*z+z*x=0 -> x*y*z=0 -> x=0.
gbZ.
Qed.

Goal forall x y z u:Z,
  x+y+z+u=0 -> 
  x*y+y*z+z*u+u*x+x*z+u*y=0 ->
  x*y*z+y*z*u+z*u*x+u*x*y=0 -> 
  x*y*z*u=0 -> x=0.
gbZ.
Qed.

Goal forall x y z u v:Z,
  x+y+z+u+v=0 -> 
  x*y+x*z+x*u+x*v+y*z+y*u+y*v+z*u+z*v+u*v=0->
  x*y*z+x*y*u+x*y*v+x*z*u+x*z*v+x*u*v+y*z*u+y*z*v+y*u*v+z*u*v=0->
  x*y*z*u+y*z*u*v+z*u*v*x+u*v*x*y+v*x*y*z=0 ->
  x*y*z*u*v=0 -> x=0.
Time gbZ. (* 2sec.*)
Qed.


Open Scope R_scope.
Record point:Type:={
 X:R;
 Y:R}.

Definition colinear(C A B:point):=
  exists a:R, 
 (X C)=a*(X A)+(1-a)*(X B) /\ (Y C)=a*(Y A)+(1-a)*(Y B).

Definition colinear2(A B C:point):=
  (X A)*(Y B)+(X B)*(Y C)+(X C)*(Y A)
  =(Y B)*(X C)+(Y C)*(X A)+(Y A)*(X B).

Ltac elimex :=
 match goal with
  | H:exists a:R, _ |- _  => elim H; clear H; intros
  |H: _/\_ |- _ => decompose [and] H; clear H
 end.

Lemma pappus: forall A B C A' B' C' D E F:point,
  (X A')=0 -> (X B')=0-> (X C')=0 ->
  (Y A)=0 -> (Y B)=0 -> (Y C) = 0 ->
  colinear D A B' -> colinear D A' B ->
  colinear E A C' -> colinear E A' C -> 
  colinear F B C' -> colinear F B' C ->
  colinear2 D E F.
unfold colinear.
unfold colinear2.
intros.
rewrite H in *;clear H.
rewrite H0 in *;clear H0.
rewrite H1 in *;clear H1.
rewrite H2 in *;clear H2.
rewrite H3 in *;clear H3.
rewrite H4 in *;clear H4.
repeat elimex.
Set Printing Depth 10000.
gbR_choice 2. (* 13 sec. *)
Qed.

Require Export gbZarith.

Goal forall a b c:Z, divides a (b*c) -> coprime a b -> divides a c.
gbarith.
Qed.

Goal forall m n r:Z, divides m r -> divides n r -> coprime m n -> divides (m*n) r.
gbarith.
Qed.

Goal forall x y a n:Z, modulo (x^2) a n -> modulo (y^2) a n -> divides n ((x+y)*(x-y)).
gbarith.
Qed.
