Require Export ZArith.
Require Import Zpow_facts.
Require Import Wf_Z.
Require Import Znumtheory.
Require Import List.
Require Export gbR.


Open Scope Z_scope.


Lemma gbZhypR: forall x y:Z, x=y -> (IZR x) = (IZR y).
Admitted.

Lemma gbZconclR: forall x y:Z, (IZR x) = (IZR y) -> x = y.
Admitted.

Lemma gbZhypnotR: forall x y:Z, x<>y -> (IZR x)<>(IZR y).
Admitted.

Lemma gbZconclnotR: forall x y:Z, (IZR x) <> (IZR y) -> x <> y.
Admitted.

Ltac gbZversR1 :=
 repeat 
  (match goal with
   | H:(@eq Z ?x ?y) |- _ => generalize (@gbZhypR _ _ H); clear H; intro H
   | |- (@eq Z ?x ?y) => apply gbZconclR
   | H:not (@eq Z ?x ?y) |- _ => generalize (@gbZhypnotR _ _ H); clear H; intro H
   | |- not (@eq Z ?x ?y) => apply gbZconclnotR
   end).

Lemma gbZR1: forall x y:Z, IZR(x+y) = (IZR(x)+IZR(y))%R.
Admitted.
Lemma gbZR2: forall x y:Z, IZR(x*y) = (IZR(x)*IZR(y))%R.
Admitted.
Lemma gbZR3: forall x y:Z, IZR(x-y) = (IZR(x)-IZR(y))%R.
Admitted.
Lemma gbZR4: forall x:Z, forall p:positive, IZR(x^(Zpos p)) = (IZR(x)^(nat_of_P p))%R.
Admitted.
Ltac gbZversR2:=
  repeat
   (rewrite gbZR1 in * ||
    rewrite gbZR2 in * ||
    rewrite gbZR3 in * ||
   rewrite gbZR4 in *).

Ltac gbZ_begin :=
 intros;
 gbZversR1;
 gbZversR2;
 simpl in *.
 (*cbv beta iota zeta delta [nat_of_P Pmult_nat plus mult] in *.*)

Ltac gbZ := 
 gbZ_begin; idtac "gbZ_begin;";
 gbR.
