Require Import gbR.


Goal  forall r r0 r1 : R,
r  = 0 ->
r0 = 0 ->
r0 * r1 + 1  = 0 ->
r - r0 = 0.

(*Time gbR.*)
 (* with JC.Faugere algorithm F4 *)
 gbR_begin; check_gbR
 (r - r0 - 0)
 (List.cons r (List.cons r0 (List.cons (r0 * r1 + 1) List.nil)))
 (List.cons r1 (List.cons r0 (List.cons r List.nil)))

(lceq (Const 1 1)
   (lceq (Const 1 1)
      (lceq (Const 0 1)
         (lceq
            (Add (Add Zero (Mul (Const 0 1) (Const 1 1)))
               (Mul (Const (-1) 1) (Pow (Var 1) 1))) (lceq (Const 1 1) lnil)))))
 .

Qed.


Goal forall x y z:R, x^2+x*y=0 -> y^2+x*y=0 -> x+y=0.
gbR.
Qed.

Goal forall x y z:R, x^2+x*y=0 -> y^2+x*y=0 -> x+y=0.
 (* with JC.Faugere algorithm F4 *)
 gbR_begin; check_gbR
 (x + y - 0)
 (List.cons (x * (x * 1) + x * y) (List.cons (y * (y * 1) + x * y) List.nil))
 (List.cons y (List.cons x List.nil))

(lceq
   (Pow
      (Add
         (Add Zero
            (Mul
               (Add (Add Zero (Mul (Const 0 1) (Const 1 1)))
                  (Mul (Const 1 1) (Pow (Var 1) 1))) (Const 1 1)))
         (Mul (Const 1 1) (Pow (Var 2) 1))) 2)
   (lceq (Const 1 1) (lceq (Const 1 1) (lceq (Const 1 1) lnil))))
 .

Qed.

Goal forall x y:R, x<>0 -> y<>0 -> x*y<>0.
gbR.
Qed.

Goal forall a b c s1 s2 s3:R, 
 s1=a+b+c->s2=a*b+b*c+a*c -> s3=a*b*c 
 -> a^3-s1*a^2+s2*a-s3=0.
Time gbR.
Qed.


Goal forall a b c d s1 s2 s3 s4:R,
 s1=a+b+c+d -> s2=a*b+a*c+a*d+b*c+b*d+c*d -> s3= a*b*c+b*c*d+c*d*a+d*a*b->s4=a*b*c*d
-> a^4 - s1*a^3 + s2*a^2 -s3*a +s4 =0.
Time gbR.
Qed.


Goal forall a b c d e s1 s2 s3 s4 s5:R,
 s1=a+b+c+d+e-> 
s2=a*b+a*c+a*d+a*e+b*c+b*d+b*e+c*d +c*e+d*e-> 
s3= a*b*c+a*b*d+a*b*e+a*c*d+a*c*e+a*d*e+b*c*d+b*c*e+b*d*e+c*d*e->
s4=a*b*c*d+a*b*c*e+a*b*d*e+a*c*d*e+b*c*d*e->
s5=a*b*c*d*e->
a^5 - s1*a^4 + s2*a^3 -s3*a^2 +s4*a-s5=0.
Time gbR_choice 2.
Qed.

(* exemple de Julien, apparemment l'enonce est faux: 
la base de grobner ne contient pas de polynome t+... *)
(*
Goal forall r r0 r1 r2 r3 r4 r5 r6 r7 r8 r9 r10:R, 
 r * r8 + r0 * r9 + r1 * r10 + 1 * 1 = 0 ->
r * r5 + r0 * r6 + r1 * r7 + 1 * 1 = 0 ->
r2 * r8 + r3 * r9 + r4 * r10 + 1 * 1 = 0 ->
r2 * r5 + r3 * r6 + r4 * r7 + 1 * 1 = 0 ->

((r - r2) * (r - r2) +
((r0 - r3) * (r0 - r3) + (r1 - r4) * (r1 - r4)) *
((r0 - r3) * (r0 - r3) + (r1 - r4) * (r1 - r4))) *
((r5 - r8) * (r5 - r8) +
((r6 - r9) * (r6 - r9) + (r7 - r10) * (r7 - r10)) *
((r6 - r9) * (r6 - r9) + (r7 - r10) * (r7 - r10))) = 0.
Time gb.
Qed.
*)
  

(* lent

Goal forall a b c d e f s1 s2 s3 s4 s5 s6:R,
 s1=a+b+c+d+e+f-> 
s2=a*b+a*c+a*d+a*e+b*c+b*d+b*e+c*d +c*e+d*e
      +f*(a+b+c+d+e)-> 
s3= a*b*c+a*b*d+a*b*e+a*c*d+a*c*e+a*d*e+b*c*d+b*c*e+b*d*e+c*d*e
       +f*(a*b+a*c+a*d+a*e+b*c+b*d+b*e+c*d +c*e+d*e)->
s4=a*b*c*d+a*b*c*e+a*b*d*e+a*c*d*e+b*c*d*e
       +f*(a*b*c+a*b*d+a*b*e+a*c*d+a*c*e+a*d*e+b*c*d+b*c*e+b*d*e+c*d*e)->
s5=a*b*c*d*e
       +f*(a*b*c*d+a*b*c*e+a*b*d*e+a*c*d*e+b*c*d*e)->
s6=a*b*c*d*e*f->
a*(a^5 - s1*a^4 + s2*a^3 -s3*a^2 +s4*a-s5)+s6=0.
Time gbR_choice 2.
Qed.
*)
(* la, quand même, il a du mal *)
(*Goal forall a b c d e f g s1 s2 s3 s4 s5 s6 s7:R,
 s1=a+b+c+d+e+f+g-> 
s2=a*b+a*c+a*d+a*e+b*c+b*d+b*e+c*d +c*e+d*e
      +f*(a+b+c+d+e)
       +g*(a+b+c+d+e+f)-> 
s3= a*b*c+a*b*d+a*b*e+a*c*d+a*c*e+a*d*e+b*c*d+b*c*e+b*d*e+c*d*e
       +f*(a*b+a*c+a*d+a*e+b*c+b*d+b*e+c*d +c*e+d*e)
        +g*(a*b+a*c+a*d+a*e+b*c+b*d+b*e+c*d +c*e+d*e
      +f*(a+b+c+d+e))->
s4=a*b*c*d+a*b*c*e+a*b*d*e+a*c*d*e+b*c*d*e
       +f*(a*b*c+a*b*d+a*b*e+a*c*d+a*c*e+a*d*e+b*c*d+b*c*e+b*d*e+c*d*e)
        +g*(a*b*c+a*b*d+a*b*e+a*c*d+a*c*e+a*d*e+b*c*d+b*c*e+b*d*e+c*d*e
       +f*(a*b+a*c+a*d+a*e+b*c+b*d+b*e+c*d +c*e+d*e))->
s5=a*b*c*d*e
       +f*(a*b*c*d+a*b*c*e+a*b*d*e+a*c*d*e+b*c*d*e)
       +g*(a*b*c*d+a*b*c*e+a*b*d*e+a*c*d*e+b*c*d*e
       +f*(a*b*c+a*b*d+a*b*e+a*c*d+a*c*e+a*d*e+b*c*d+b*c*e+b*d*e+c*d*e))->
s6=a*b*c*d*e*f
      +g*(a*b*c*d*e
       +f*(a*b*c*d+a*b*c*e+a*b*d*e+a*c*d*e+b*c*d*e))->
s7=a*b*c*d*e*f*g->
a*(a*(a^5 - s1*a^4 + s2*a^3 -s3*a^2 +s4*a-s5)+s6)-s7=0.
Time gbR.
Qed.

*)

(************* Examples in Z. ******************************)

Require Import gbZ.



Goal forall x y z u:Z,
  x+y+z+u=0 -> 
  x*y+y*z+z*u+u*x+x*z+u*y=0 ->
  x*y*z+y*z*u+z*u*x+u*x*y=0 -> 
  x*y*z*u=0 -> x=0.
Time gbZ.
Qed.
Goal forall x y z u v:Z,
  x+y+z+u+v=0 -> 
  x*y+x*z+x*u+x*v+y*z+y*u+y*v+z*u+z*v+u*v=0->
  x*y*z+x*y*u+x*y*v+x*z*u+x*z*v+x*u*v+y*z*u+y*z*v+y*u*v+z*u*v=0->
  x*y*z*u+y*z*u*v+z*u*v*x+u*v*x*y+v*x*y*z=0 ->
  x*y*z*u*v=0 -> x=0.
Time gbZ.
Qed.
Goal forall x y z:Z, x^2+x*y=0 -> y^2+x*y=0 -> x+y=0.
gbZ.
Qed.

Goal forall x y z:Z, x^2+x*y=0 -> y^2+x*y=0 -> x+y=0.
 gbZ_begin;
 (* with JC.Faugere algorithm F4 *)
 gbR_begin; check_gbR

(List.hd 0%R
   (List.rev
      (interpret_list
         (lceq
            (Add (Mul (Var 2) (Mul (Var 2) (Const 1 1)))
               (Mul (Var 1) (Var 2)))
            (lceq
               (Add (Mul (Var 1) (Mul (Var 1) (Const 1 1)))
                  (Mul (Var 1) (Var 2)))
               (lceq (Sub (Add (Var 1) (Var 2)) (Const 0 1)) lnil)))
         (List.cons (IZR x) (List.cons (IZR y) List.nil)))))

(List.rev
   (List.tail
      (List.rev
         (interpret_list
            (lceq
               (Add (Mul (Var 2) (Mul (Var 2) (Const 1 1)))
                  (Mul (Var 1) (Var 2)))
               (lceq
                  (Add (Mul (Var 1) (Mul (Var 1) (Const 1 1)))
                     (Mul (Var 1) (Var 2)))
                  (lceq (Sub (Add (Var 1) (Var 2)) (Const 0 1)) lnil)))
            (List.cons (IZR x) (List.cons (IZR y) List.nil))))))
 (List.cons (IZR x) (List.cons (IZR y) List.nil))

(lceq
   (Pow
      (Add
         (Add Zero
            (Mul
               (Add (Add Zero (Mul (Const 0 1) (Const 1 1)))
                  (Mul (Const 1 1) (Pow (Var 1) 1))) (Const 1 1)))
         (Mul (Const 1 1) (Pow (Var 2) 1))) 2)
   (lceq (Const 1 1) (lceq (Const 1 1) (lceq (Const 1 1) lnil))))
 .

Qed.

Goal  forall r r0 r1 : Z,
r  = 0 ->
r0 = 0 ->
r0 * r1 + 1  = 0 ->
r - r0 = 0.

Time gbZ.
Qed.

Goal forall a b c s1 s2 s3:Z, 
 s1=a+b+c->s2=a*b+b*c+a*c -> s3=a*b*c 
 -> a^3-s1*a^2+s2*a-s3=0.
Time gbZ.
Qed.


Goal forall a b c d s1 s2 s3 s4:Z,
 s1=a+b+c+d -> s2=a*b+a*c+a*d+b*c+b*d+c*d -> s3= a*b*c+b*c*d+c*d*a+d*a*b->s4=a*b*c*d
-> a^4 - s1*a^3 + s2*a^2 -s3*a +s4 =0.
Time gbZ.
Qed.

(*
Goal forall a b c d e s1 s2 s3 s4 s5:Z,
 s1=a+b+c+d+e-> 
s2=a*b+a*c+a*d+a*e+b*c+b*d+b*e+c*d +c*e+d*e-> 
s3= a*b*c+a*b*d+a*b*e+a*c*d+a*c*e+a*d*e+b*c*d+b*c*e+b*d*e+c*d*e->
s4=a*b*c*d+a*b*c*e+a*b*d*e+a*c*d*e+b*c*d*e->
s5=a*b*c*d*e->
a^5 - s1*a^4 + s2*a^3 -s3*a^2 +s4*a-s5=0.
Time gbZ.
Qed.
*)

(************* Proofs of arithmetical propeties *************************)

Require Import gbZarith.

Goal forall x y:Z, divides (x+y) (x^7+y^7).
gbarith.
Qed.

Goal forall a b c:Z, divides a (b*c) -> coprime a b -> divides a c.
gbarith.
Qed.

Goal forall x y:Z, coprime (x*y) (x^2+y^2) <-> coprime x y.
gbarith.
Qed.

Goal forall x y a n:Z, modulo (x+a) (y+a) n <-> modulo x y n.
gbarith.
Qed.

Goal forall x n:Z, modulo x 0 n <-> divides n x.
gbarith.
Qed.

Goal forall x y n:Z, modulo x y n -> (coprime n x <-> coprime n y).
gbarith.
Qed.

Goal forall a b c x y:Z, gcd x a b -> divides y a -> divides y b -> divides y x.
gbarith.
Qed.

Goal forall a x y n:Z, modulo (a*x) (a*y) n -> coprime a n -> modulo x y n.
gbarith.
Qed.

Goal forall d a b:Z, divides d a -> divides d b -> divides d (a-b).
gbarith.
Qed.

Goal forall a b c:Z, divides a b -> divides (c*a) (c*b).
gbarith.
Qed.

Goal forall x d a:Z, divides (x*d) a -> divides d a.
gbarith.
Qed.

Goal forall a b c d:Z, divides a b -> divides c d -> divides (a*c) (b*d).
gbarith.
Qed.

Goal forall a b d:Z, coprime d a -> coprime d b -> coprime d (a*b).
gbarith.
Qed.

Goal forall a b d:Z, coprime d (a*b) -> coprime d a.
gbarith.
Qed.

Goal forall m n r:Z, divides m r -> divides n r -> coprime m n -> divides (m*n) r.
gbarith.
Qed.

Goal forall x x' y y' n:Z, modulo x x' n -> modulo y y' n -> modulo (x*y) (x'*y') n.
gbarith.
Qed.

Goal forall x y m n:Z, modulo x y m -> divides n m -> modulo x y n.
gbarith.
Qed.

Goal forall a b x y:Z, coprime a b -> modulo x y a -> modulo x y b -> modulo x y (a*b).
gbarith.
Qed.

Goal forall x y:Z, modulo (x^2) (y^2) (x+y).
gbarith.
Qed.

Goal forall x y a n:Z, modulo (x^2) a n -> modulo (y^2) a n -> divides n ((x+y)*(x-y)).
gbarith.
Qed.

(* ne marche pas, car il faut savoir que 4=2*2 
Goal forall a b p:Z, modulo a 0 2 -> modulo b 0 2 -> modulo (a*b) 0 4.
*)

(*
Goal forall a b p:Z, modulo a 0 p -> modulo b 0 p -> modulo (a*b) 0 (p^2).
gbarith.
Qed.
*)
